<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>intro-2-ruby</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
</head>
<body>
<h1 id="introduction-to-ruby">Introduction to Ruby</h1>
<h2 id="why-learn-ruby">Why Learn Ruby?</h2>
<ul>
<li>It has learned/stolen a ton from the languages that came before it.</li>
<li>It’s elegant and easy to learn</li>
<li>It doesn’t focus on making code as short as possible, it cares about readability</li>
<li>It has a huge community behind it - documentation, tutorials, etc.</li>
<li>RAILS! Ruby is a well designed object oriented language. It is easy to read and stresses the DRY (Don’t Repeat Yourself) principle. Since many of the method names and the ruby syntax itself is so much like english, it is an ideal language to start with.</li>
</ul>
<h2 id="objectives">Objectives</h2>
<ul>
<li>Ruby docs</li>
<li>Variables and assignments</li>
<li>Strings</li>
<li>Symbols</li>
<li>Fixnum, Float</li>
<li>Input and Output</li>
<li>Arrays</li>
<li>Booleans</li>
</ul>
<h2 id="my-first-ruby-app---basic-hello-world">My First Ruby App - basic Hello World</h2>
<ul>
<li>Everyone let’s make a new folder for our ruby exercises:
<ul>
<li><code>mkdir ruby_exercises</code></li>
</ul></li>
<li>Make a new ruby file
<ul>
<li><code>subl ex1.rb</code></li>
</ul></li>
<li>Add this to the file:
<ul>
<li><code>puts 'hello world'</code></li>
<li><code>puts 'my name is Bryan'</code></li>
</ul></li>
<li>Now let’s run our code. Execute it with:
<ul>
<li><code>ruby ex1.rb</code></li>
</ul></li>
<li>Ok great, our first program! Let’s add a comment and then run our code:
<ul>
<li><code>#this code won't run!</code></li>
</ul></li>
<li>Now let’s do something different
<ul>
<li><code>puts '2 + 2'</code></li>
</ul></li>
<li>Oh now! That’s not what we want. How can we get it to evaluate the expression?
<ul>
<li><code>puts 2+ 2</code></li>
</ul></li>
<li>So what’s the difference? When we use quotes, we are making a <strong>string</strong>. It’s text and isn’t evaluated.</li>
</ul>
<p>##Let’s talk about numbers and math! So let’s do some more math besides just <code>2 + 2</code></p>
<ul>
<li>To play around with some math expressions, we’re going to use something called <strong>IRB</strong>. It allows us to execute short bits of Ruby code without saving it to a file and running it in the terminal.</li>
<li>In IRB we can evaluate simple expressions:</li>
</ul>
<pre><code>puts &quot;This is IRB!&quot;
5
1000009 </code></pre>
<p>So we have numbers! We can do some operations with those numbers:</p>
<pre><code>2+2
46-100
10*20
81/9
1/3 # notice what happens when we run this.</code></pre>
<ul>
<li>We run into a problem! That shouldn’t be 0. So what’s going on?</li>
<li><strong>Integers </strong>are numbers without decimal points</li>
<li><strong>Floating-Point Numbers</strong> (floats) are numbers with decimal points</li>
</ul>
<p>These expressions follow the order of operations. So we can do something like: <code>10 * (25 - 1)</code></p>
<h2 id="exercise-time">EXERCISE TIME!</h2>
<p>Write a program that outputs the number of minutes in a decade <code>puts 60 * 24 * (365 * 10 + 2)</code></p>
<h2 id="so-lets-go-back-to-strings">So let’s go back to Strings</h2>
<ul>
<li>Strings are basically groups of letters. Things like:
<ul>
<li><code>Ruby is awesome</code></li>
</ul></li>
<li>As you’ve seen already we use <code>puts</code> to print things</li>
<li>String Arithmetic.
<ul>
<li>You can sort of add 2 strings
<ul>
<li><code>puts 'I like' + 'ice cream'</code></li>
</ul></li>
<li>We can also multiply them
<ul>
<li>puts “Hello World” * 100</li>
</ul></li>
<li><p>Make sure we know the difference between numbers and digits:</p>
<pre><code>puts 2 * 5
puts &#39;2&#39; * 5
puts &#39;2 * 5&#39;</code></pre></li>
</ul></li>
</ul>
<p>What if we want to print out the string “You’re awesome”</p>
<p><code>puts 'You\'re awesome'</code></p>
<p>Ok, so what if we want to type the ‘\’ character like in ‘Up’</p>
<pre><code>puts &quot;up\\down&quot;
puts &quot;This should go on a \n new line&quot;</code></pre>
<h2 id="booleans">Booleans</h2>
<p>Booleans can only have 2 values. TRUE or FALSE</p>
<pre><code>100 &gt; 1
60 &lt; 20</code></pre>
<h2 id="variables">VARIABLES</h2>
<p>So far, we’ve learned about data types, but we can’t do anything with these values. Variables allow us to store values and use them later. Here’s a really simple example.</p>
<pre><code>puts &#39;you can say that again&#39;
puts &#39;you can say that again&#39;
# We can use a variable to help us out here
#Variables have 2 parts - NAME and VALUE
my_string = &#39;you can say that again&#39;
puts my_string
puts my_string</code></pre>
<p>So we’re storing a value in the computer’s memory for later use. You can think of it as my_string is pointing to ‘you can say that again’</p>
<p>Of course variables can point to any data type. So let’s try another example:</p>
<pre><code>score_1 = 99.5
score_2 = 80
average = (score_1 + score_2)/2
**#what happens if we do this:**

puts  &quot;The average test score is: &quot; + average

It doens&#39;t work, so we need string interpolation!
puts &quot;The average test score is #{average}&quot;</code></pre>
<p><strong>String Interpolation</strong></p>
<p>When naming variables, most Ruby programmers use <strong>snake_case</strong></p>
<h3 id="code-along">Code Along</h3>
<p>We are going to make a simple app that asks for your first name and greets you:</p>
<pre><code>name = gets.chomp
puts &quot;Hey there, #{name}&quot;</code></pre>
<p>Now on your own, let’s adapt it so that it asks for our middle and last name as well.</p>
<h2 id="some-more-string-methods">Some More String Methods</h2>
<p><a href="http://www.ruby-doc.org/">RUBY DOCS</a></p>
<pre><code>first_name = &quot;Tim&quot;
last_name = &quot;Garcia&quot;

# This is an example of String concatentation
# full name will be &quot;Tim Garcia&quot;
full_name = first_name + &quot; &quot; + last_name

# This is an example of String interpolation
full_name = &quot;#{first_name} #{last_name}&quot;

# Returns the length of the string
full_name.length
# Also returns the length of the string literal
&quot;Tim Garcia&quot;.length

# Returns full name but all characters in lower case.
# This does not save any changes to full_name iteself
full_name.downcase

# This will still print &quot;Tim Garcia&quot;
puts full_name

# Saves the downcased value of the string to full_name. 
full_name.downcase!

# This will print &quot;tim garcia&quot;, because of the call to downcase!
puts full_name

# String access.  full_name is once again Tim Garcia
full_name[0] = &#39;T&#39;
full_name[4] = &#39;G&#39;

# Will print &#39;a&#39; to STDOUT.  &#39;a&#39; is the last character in the full_name String
puts full_name[-1] </code></pre>
<h4 id="exercise">Exercise</h4>
<p>Let’s add on to our greeter program. Ask the user what city and state they live in. Output the capitalized city name and all upercase state name. Explore the Ruby docs to find out how to capitalize only the first letter.</p>
<p><strong>Code Along</strong> We’ll make a simple app that asks the user how old they are. It will then tell them how many seconds they have lived.</p>
<pre><code>puts &quot;How old are you?&quot;
age = gets.chomp
age = age.to_i
seconds = age * 365 * 24 * 60 *60
puts &quot;You&#39;ve been alive for #{seconds} seconds&quot;</code></pre>
<p>#ARRAYS Arrays are a data structure that can hold multiple objects. It’s basically a list of values.</p>
<pre><code>my_array = []
another_array = Array.new
array_3 = [4, 6, 3, 1]
word_array = [&quot;I&quot;, &quot;like&quot;, &quot;chocolate&quot;]
array_of_arrays = [my_array, another_array, array_3, word_array]</code></pre>
<p><strong>Accessing Arrays</strong></p>
<pre><code>arr = [&quot;Ruby&quot;, &quot;is&quot;, &quot;awesome&quot;]
puts arr[0]
puts arr[2]
puts arr[-1]
</code></pre>
<p><strong>Modifying an array</strong></p>
<h3 id="modifying-an-array">Modifying an Array</h3>
<p>Arrays can be modified by assigning a value directly to an index or by adding values or removing them from the object.</p>
<pre><code>arr = [1,2,99]

# Array is now [1,2,3]
arr[2] = 3

# This adds a new value to the end of the array
# Array is now [1,2,3,4]
arr[3] = 4</code></pre>
<pre><code>arr = [1, 2, 3, 4, 5, 6, 7]

# The array will now be [1, 2, 3, 4, 5, 6, 7, 8, 9]
arr.push 8
arr.push 9

# The array will now be [1, 2, 3, 4, 5]
arr.pop
arr.pop
arr.pop
arr.pop

# The array will now be [3, 4, 5]
arr.shift
arr.shift

# The array will now be [1, 2, 3, 4, 5]
arr.unshift 2
arr.unshift 1</code></pre>
<p>Arrays can also be concatenated together. For example, if you have array <code>[1,2,3]</code> and <code>[4,5,6,]</code>. You can use concat to add [4,5,6] to the array.</p>
<pre><code>arr = [1,2,3]
arr.concat [4,5,6]

# Prints [1,2,3,4,5,6]
puts arr.to_s</code></pre>
<p>Keep in mind that the array will take up space from index 0 to the last index that you create. So the code below creates a large array of values that you probably do not want:</p>
<pre><code>arr = []
arr[9999] = 1</code></pre>
<h3 id="code-along-1">Code Along</h3>
<p>We’re going to make a program that stores a list of students in the class and then outputs them.</p>
<pre><code>students = []
puts &quot;Add a name&quot;
students.push (gets.chomp)
puts &quot;Add a name&quot;
students.push (gets.chomp)
puts &quot;Add a name&quot;
students.push (gets.chomp)
p students</code></pre>
<h3 id="exercise-1"><strong>Exercise</strong></h3>
<p>Make an app that asks the user for 5 numbers. Store them in an array. At the end, output the numbers from lowest to highest. Look in the array documentation on Ruby Docs.</p>
</body>
</html>
